SystemOrganization addCategory: #'Glamour-Core'!

Announcer subclass: #GLMPane
	instanceVariableNames: 'browser name presentations ports'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMPane classSide methodsFor: 'as yet unclassified' stamp: 'jorge.ressia 6/3/2009 09:09'!
in: aBrowser 
	
	^self new initializeIn: aBrowser! !

!GLMPane classSide methodsFor: 'instance creation' stamp: 'jorge.ressia 6/2/2009 23:42'!
named: aString 
	^self new initializeNamed: aString! !

!GLMPane classSide methodsFor: 'as yet unclassified' stamp: 'jorge.ressia 6/2/2009 20:28'!
named: aString in: aBrowser

	^self new initializeNamed: aString in: aBrowser 
! !

!GLMPane classSide methodsFor: 'private' stamp: ' 4/5/09 22:18'!
portClass 
	 
	^GLMPanePort! !

!GLMPane methodsFor: 'accessing' stamp: 'jorge.ressia 6/3/2009 08:49'!
addPresentation: aPresentation 
	 
	self 
		notingPresentationChangeDo: 
			[presentations 
				addLast: 
					(aPresentation 
						pane: self; 
						yourself)]! !

!GLMPane methodsFor: 'accessing' stamp: 'jorge.ressia 6/3/2009 09:18'!
addPresentations: aCollection 
	 
	self 
		notingPresentationChangeDo: 
			[aCollection 
				do: 
					[:each |  
					presentations 
						addLast: 
							(each 
								pane: self; 
								yourself)]]! !

!GLMPane methodsFor: 'converting' stamp: ' 4/5/09 22:18'!
asGlamorousPane 
	 
	^self! !

!GLMPane methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
browser 
	 
	^browser! !

!GLMPane methodsFor: 'accessing' stamp: 'jre 9/19/2009 08:25'!
clear 
	self notingPresentationChangeDo: [presentations := OrderedCollection new]. 
	self ports do: [:each | each value: nil ]! !

!GLMPane methodsFor: 'accessing' stamp: 'jre 9/19/2009 08:25'!
clearIn: aContext 

	self notingPresentationChangeDo: [presentations := OrderedCollection new]. 
	self ports do: [:each | each value: nil in: aContext]! !

!GLMPane methodsFor: 'initialization' stamp: 'jorge.ressia 6/3/2009 09:10'!
defaultName

	^'undefined'! !

!GLMPane methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
hasBrowser 
	 
	^self browser isNil not! !

!GLMPane methodsFor: 'initialization' stamp: 'jorge.ressia 6/3/2009 09:10'!
initializeIn: aBrowser 
	
	self initializeNamed: self defaultName in: aBrowser! !

!GLMPane methodsFor: 'initialization' stamp: 'jorge.ressia 6/2/2009 23:43'!
initializeNamed: aString 
	self initializeNamed: aString in: GLMNoBrowser new  ! !

!GLMPane methodsFor: 'initialization' stamp: ''!
initializeNamed: aString in: aBrowser 
	name := aString ifNil: [ self defaultName ].
	browser := aBrowser.
	ports := OrderedCollection new.
	presentations := OrderedCollection new.! !

!GLMPane methodsFor: 'accessing' stamp: 'jorge.ressia 6/3/2009 09:18'!
matchingPresentations 
	 
	^presentations select: [:each | each matches]! !

!GLMPane methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
name 
	 
	^name! !

!GLMPane methodsFor: 'private' stamp: ' 4/5/09 22:18'!
notingPresentationChangeDo: aBlock 
	 
	| oldPresentations oldMatchingPresentations | 
	oldPresentations := self presentations copy. 
	oldMatchingPresentations := self matchingPresentations. 
	aBlock value. 
	self presentations ~= oldPresentations 
		ifTrue: 
			[self 
				announce: 
					((GLMPresentationsChanged new) 
						pane: self; 
						oldPresentations: oldPresentations; 
						yourself)]. 
	self matchingPresentations ~= oldMatchingPresentations 
		ifTrue: 
			[self 
				announce: 
					((GLMMatchingPresentationsChanged new) 
						pane: self; 
						oldMatchingPresentations: oldMatchingPresentations; 
						yourself)]! !

!GLMPane methodsFor: 'accessing' stamp: 'jorge.ressia 6/3/2009 08:46'!
port: aSymbol 
	 
	^ports 
		detect: [:each | each name = aSymbol] 
		ifNone: 
			[ports 
				addLast: 
					((self class portClass new) 
						pane: self; 
						name: aSymbol; 
						yourself)]! !

!GLMPane methodsFor: 'private' stamp: 'jorge.ressia 6/2/2009 23:07'!
portEvent: aPortEvent 
	 
	self browser innerPortEvent: aPortEvent.
	self presentations do: [:each | each outerPortEvent: aPortEvent]! !

!GLMPane methodsFor: 'accessing' stamp: 'jorge.ressia 6/3/2009 08:06'!
ports 
	 
	^OrderedCollection withAll: ports! !

!GLMPane methodsFor: 'private' stamp: ' 4/5/09 22:18'!
postCopy 
	 
	super postCopy! !

!GLMPane methodsFor: 'accessing' stamp: 'jorge.ressia 6/3/2009 09:17'!
presentations 
	 
	^OrderedCollection withAll: presentations! !

!GLMPane methodsFor: 'as yet unclassified' stamp: 'DamienCassou 9/10/2009 19:45'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $(;
		print: self name;
		nextPut: $)! !

!GLMPane methodsFor: 'rendering' stamp: ' 4/5/09 22:18'!
renderGlamorouslyOn: aRenderer 
	 
	^aRenderer renderPane: self! !

!GLMPane methodsFor: 'announcements' stamp: ' 4/5/09 22:18'!
whenMatchingPresentationsChanged: aBlock 
	 
	^self when: GLMMatchingPresentationsChanged do: aBlock! !

!GLMPane methodsFor: 'announcements' stamp: ' 4/5/09 22:18'!
whenPresentationsChanged: aBlock 
	 
	^self when: GLMPresentationsChanged do: aBlock! !

Announcer subclass: #GLMPresentation
	instanceVariableNames: 'pane title transformation actions condition isInspectable implicitNotNil postTransformation dynamicActionsBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

GLMPresentation subclass: #GLMBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMBrowser commentStamp: '<historical>' prior: 0!
Browsers are one of the core components in Glamour.

They contain panes and transmission between them, which can either be explicitely defined by the user (such as in the TableLayoutBrowser) or implicitely defined (such as in the Finder).

Browsers serve as composition managers. They determine when and under which conditions transmissions should be triggered and how they connect the ports of panes. In return, panes inform the browsers when event occur on their ports so that the browser can make an informed decission on what to do.!

!GLMBrowser methodsFor: 'scripting-private' stamp: 'tg 5/24/2009 19:15'!
initializeScriptingDefaults 
	"Initialize some default behavior if the user did not explcitly script it. 
 
	Subclasses can use this to create a default startup transmission or show 
	a default pane or something like that." 
	
	^self! !

!GLMBrowser methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
panes 
	"Return an (ordered) collection of the panes used by this browser." 
	 
	self subclassResponsibility! !

GLMBrowser subclass: #GLMExplicitBrowser
	instanceVariableNames: 'panes hiddenPane transmissions jumpstartTransmissions scriptTransmission'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMExplicitBrowser methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
addJumpstart: aTransmission 
	 
	self jumpstartTransmissions addLast: aTransmission! !

!GLMExplicitBrowser methodsFor: 'accessing' stamp: 'jorge.ressia 6/2/2009 21:48'!
addNewPane
	
	^self addNewPaneNamed: 'undefined'! !

!GLMExplicitBrowser methodsFor: 'accessing' stamp: 'jorge.ressia 6/2/2009 21:48'!
addNewPaneNamed: aString
	
	^self panes addLast: (GLMPane named: aString in: self)! !

!GLMExplicitBrowser methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
addPane: aPane 
	 
	aPane browser: self. 
	self panes addLast: aPane! !

!GLMExplicitBrowser methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
addTransmission: aTransmission 
	 
	self transmissions addLast: aTransmission! !

!GLMExplicitBrowser methodsFor: 'events' stamp: 'jre 9/19/2009 11:34'!
innerPortEvent: aPortEvent 
	aPortEvent hasChanged 
		ifTrue: 
			[(self transmissions select: [:each | ( each originatesAt: aPortEvent port ) and: [( aPortEvent transmissionContext includes: each destination) not ]]) 
				do: [:each | each transmitIn: aPortEvent transmissionContext ]]! !

!GLMExplicitBrowser methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
jumpstartTransmissions 
	 
	^jumpstartTransmissions 
		ifNil: [jumpstartTransmissions := OrderedCollection new]! !

!GLMExplicitBrowser methodsFor: 'events' stamp: 'jre 9/19/2009 10:55'!
outerPortEvent: aPortEvent  
	super outerPortEvent: aPortEvent.	"Hack for a jumpstart transmission (we should clean this up)." 
	aPortEvent portName = #entity 
		ifTrue: 
			[self jumpstartTransmissions 
				do: 
					[:each |  
					each 
						clearOrigins; 
						addActiveOrigin: (self pane port: #entity); 
						transmit]]. 
	aPortEvent hasChanged 
		ifTrue: 
			[(self transmissions select: [:each | (each originatesAt: aPortEvent port) and: [( aPortEvent transmissionContext includes: each destination) not ]]) 
				do: [:each | each transmitIn: aPortEvent transmissionContext ]]! !

!GLMExplicitBrowser methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
paneNamed: aSymbol 
	 
	^self panes detect: [:each | each name = aSymbol]! !

!GLMExplicitBrowser methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
panes 
	 
	^panes ifNil: [panes := OrderedCollection new]! !

!GLMExplicitBrowser methodsFor: 'copying' stamp: 'tg 9/6/2009 00:58'!
postCopy
	super postCopy.
	self flag: 'we should somehow copy the panes, the ports and have the transmissions. The trouble is how to copy the transmissions between the ports that we just copied.'.
"	panes := panes collect: [:each | each copy].
	transmissions := self transmissions collect: [:each | each copy].
	jumpstartTransmissions := self jumpstartTransmissions collect: [:each | each copy]."! !

!GLMExplicitBrowser methodsFor: 'accessing' stamp: ' 11/3/09 10:15'!
pulledPorts 
	 
	^pulledPorts ifNil: [pulledPorts := OrderedCollection new]! !

!GLMExplicitBrowser methodsFor: 'accessing' stamp: ' 11/3/09 10:15'!
pushedPorts 
	 
	^pushedPorts ifNil: [pushedPorts := OrderedCollection new]! !

!GLMExplicitBrowser methodsFor: 'scripting-private' stamp: ' 4/5/09 22:18'!
resolveDestinationPort: aPortReference 
	 
	^self resolvePort: aPortReference defaultPortName: #entity! !

!GLMExplicitBrowser methodsFor: 'scripting-private' stamp: ' 4/5/09 22:18'!
resolveOriginPort: aPortReference 
	 
	^self resolvePort: aPortReference defaultPortName: #selection! !

!GLMExplicitBrowser methodsFor: 'scripting-private' stamp: ' 4/5/09 22:18'!
resolvePort: aPortReference defaultPortName: aSymbol 
	 
	| tmp | 
	tmp := aPortReference. 
	(tmp isKindOf: GLMPane) ifTrue: [tmp := tmp port: aSymbol]. 
	(tmp isKindOf: GLMPort) ifTrue: [^tmp]. 
	tmp isSymbol ifTrue: [tmp := tmp -> aSymbol]. 
	(tmp isKindOf: Association) 
		ifTrue: 
			[^tmp key = #outer 
				ifTrue: 
					[(GLMParentPort new) 
						presentation: self; 
						name: tmp value; 
						yourself] 
				ifFalse: [(self paneNamed: tmp key) port: tmp value]]. 
	self error: 'Unknown port reference.'! !

!GLMExplicitBrowser methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
transmissions 
	 
	^transmissions ifNil: [transmissions := OrderedCollection new]! !

!GLMExplicitBrowser methodsFor: 'accessing' stamp: 'jorge.ressia 6/2/2009 23:25'!
updateContextWith: aPane 
! !

GLMBrowser subclass: #GLMImplicitBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMPresentation methodsFor: 'accessing' stamp: 'tg 8/4/2009 15:19'!
actions
	actions ifNil: [actions := OrderedCollection new].
	^ actions! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
addAction: anAction 
	 
	self actions addLast: anAction! !

!GLMPresentation methodsFor: 'accessing' stamp: 'tg 8/4/2009 15:19'!
allActions 
	^ self actions, self dynamicActions! !

!GLMPresentation methodsFor: 'accessing' stamp: 'tg 8/25/2009 15:01'!
beInspectable 
	self flag: 'reconsider this part'.
	^isInspectable := true! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
condition 
	 
	^condition ifNil: [condition := [true]]! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
condition: anObject 
	 
	condition := anObject! !

!GLMPresentation methodsFor: 'accessing' stamp: 'tg 8/1/2009 16:49'!
displayValue
	^ self transformation glamourValue: self entity! !

!GLMPresentation methodsFor: 'accessing' stamp: 'tg 8/4/2009 15:11'!
dynamicActions
	dynamicActionsBlock isNil ifTrue: [ ^ OrderedCollection new ].
	^ dynamicActionsBlock value: self! !

!GLMPresentation methodsFor: 'accessing ports' stamp: ' 4/5/09 22:18'!
entity 
	 
	^(self pane port: #entity) value! !

!GLMPresentation methodsFor: 'accessing ports' stamp: ' 4/5/09 22:18'!
entity: anObject 
	 
	(self pane port: #entity) value: anObject! !

!GLMPresentation methodsFor: 'events' stamp: ' 4/5/09 22:18'!
innerPortEvent: aPortEvent 
	 
	! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
isInspectable 
	 
	^isInspectable ifNil: [isInspectable := false]! !

!GLMPresentation methodsFor: 'testing' stamp: ''!
matches 
	^(self usesImplicitNotNil 
		ifTrue: [GLMNotNilCondition new glamourValue: self entity] 
		ifFalse: [true]) and: [(self condition glamourValue: self entity) = true]! !

!GLMPresentation methodsFor: 'events' stamp: ' 4/5/09 22:18'!
outerPortEvent: aPortEvent 
	 
	self 
		announce: 
			((GLMContextChanged new) 
				presentation: self; 
				property: aPortEvent portName; 
				value: aPortEvent value; 
				oldValue: aPortEvent oldValue; 
				yourself)! !

!GLMPresentation methodsFor: 'accessing' stamp: 'jorge.ressia 6/3/2009 09:10'!
pane 
	 
	^pane 
		ifNil: 
			[pane := (GLMPane in: GLMNoBrowser new) 
				addPresentation: self; 
				yourself]! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
pane: aPane 
	 
	pane := aPane! !

!GLMPresentation methodsFor: 'copying' stamp: ' 4/5/09 22:18'!
postCopy 
	 
	super postCopy! !

!GLMPresentation methodsFor: 'accessing' stamp: 'tg 8/1/2009 16:49'!
postTransformation
	"this is used for transforming the object before updating the selection"
	^ postTransformation ifNil: [postTransformation := #yourself]! !

!GLMPresentation methodsFor: 'rendering' stamp: ' 4/5/09 22:18'!
renderGlamorouslyOn: aRenderer 
	 
	^aRenderer renderPresentation: self! !

!GLMPresentation methodsFor: 'accessing ports' stamp: ' 4/5/09 22:18'!
selection 
	 
	^(self pane port: #selection) value! !

!GLMPresentation methodsFor: 'accessing ports' stamp: 'tg 8/25/2009 15:48'!
selection: anObject 
	 
	(self pane port: #selection) value: (self postTransformation glamourValue: anObject)! !

!GLMPresentation methodsFor: 'accessing' stamp: 'tg 8/25/2009 16:01'!
selectionTransformation: anObject 
	postTransformation := anObject! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
title 
	 
	^title ifNil: [title := #glamourString]! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
title: aStringOrBlock 
	 
	title := aStringOrBlock! !

!GLMPresentation methodsFor: 'accessing' stamp: 'tg 9/14/2009 21:35'!
titleValue
	| value |
	^ title isNil
		ifTrue: [
			value := self entity glamourString.
			value size > 16 ifTrue: [ value := (value copyFrom: 1 to: 12), ' ...' ].	
			value ]
		ifFalse: [ self title glamourValue: self entity ]! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
transformation 
	 
	^transformation ifNil: [transformation := #yourself]! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
transformation: aBlock 
	 
	transformation := aBlock! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
useExplicitNotNil 
	 
	implicitNotNil := false! !

!GLMPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
useImplicitNotNil 
	 
	implicitNotNil := true! !

!GLMPresentation methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
usesExplicitNotNil 
	 
	^self usesImplicitNotNil not! !

!GLMPresentation methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
usesImplicitNotNil 
	 
	^implicitNotNil ifNil: [implicitNotNil := true]! !

!GLMPresentation methodsFor: 'announcements' stamp: ' 4/5/09 22:18'!
whenContextChanged: aBlock 
	 
	^self when: GLMContextChanged do: aBlock! !

OrderedCollection variableSubclass: #GLMMultiValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMMultiValue methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
asGlamorousArray 
	 
	^self asArray! !

!GLMMultiValue methodsFor: 'testing' stamp: 'tg 9/9/2009 01:02'!
asGlamorousMultiValue
	^ self! !

Announcement subclass: #GLMContextChanged
	instanceVariableNames: 'presentation property value oldValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMContextChanged methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
announcesNewSelection 
	"ContextChanged announces a new selection if 
	the updated port is #selection and the new value is different from the current selection. 
	This method is useful when updating the selection in UI widgets, because 
	we only want to affect the widget when there actually is a new selection" 
	 
	^self property = #selection 
		and: [self presentation selection ~~ self value]! !

!GLMContextChanged methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
oldValue 
	 
	^oldValue! !

!GLMContextChanged methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
oldValue: anObject 
	 
	oldValue := anObject! !

!GLMContextChanged methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
presentation 
	 
	^presentation! !

!GLMContextChanged methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
presentation: aPresentation 
	 
	presentation := aPresentation! !

!GLMContextChanged methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
property 
	 
	^property! !

!GLMContextChanged methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
property: aSymbol 
	 
	property := aSymbol! !

!GLMContextChanged methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
value 
	 
	^value! !

!GLMContextChanged methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
value: anObject 
	 
	value := anObject! !

Announcement subclass: #GLMMatchingPresentationsChanged
	instanceVariableNames: 'pane oldMatchingPresentations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMMatchingPresentationsChanged methodsFor: 'accessing-convenience' stamp: ' 4/5/09 22:18'!
matchingPresentations 
	"The presentations that match now." 
	 
	^self pane matchingPresentations! !

!GLMMatchingPresentationsChanged methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
oldMatchingPresentations 
	"The presentations that matched before this announcement." 
	 
	^oldMatchingPresentations! !

!GLMMatchingPresentationsChanged methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
oldMatchingPresentations: aCollection 
	"The presentations that matched before this announcement." 
	 
	oldMatchingPresentations := aCollection! !

!GLMMatchingPresentationsChanged methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
pane 
	"The pane on which the matching presentations changed." 
	 
	^pane! !

!GLMMatchingPresentationsChanged methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
pane: aPane 
	"The pane on which the matching presentations changed." 
	 
	pane := aPane! !

Announcement subclass: #GLMPresentationsChanged
	instanceVariableNames: 'pane oldPresentations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMPresentationsChanged methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
oldPresentations 
	"The presentations that were present on the pane before the change." 
	 
	^oldPresentations! !

!GLMPresentationsChanged methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
oldPresentations: aCollection 
	"The presentations that were present on the pane before the change." 
	 
	oldPresentations := aCollection! !

!GLMPresentationsChanged methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
pane 
	"The pane on which the presentations changed." 
	 
	^pane! !

!GLMPresentationsChanged methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
pane: aPane 
	"The pane on which the presentations changed." 
	 
	pane := aPane! !

!GLMPresentationsChanged methodsFor: 'accessing-convenience' stamp: ' 4/5/09 22:18'!
presentations 
	"The presentationt that are currently present on the pane." 
	 
	^self pane presentations! !

Object subclass: #GLMAction
	instanceVariableNames: 'action title shortcut position category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMAction commentStamp: '<historical>' prior: 0!
Actions are elements of behavior that are executed upon a keyboard shortcut or other event.

Instances of Action are stored and maintained by Presentations. The exact representation is determined by the renderer, but actions can define a keyboard shortcut that should trigger the action or a title, category and position to be able to use the action as a context menu item.!

!GLMAction methodsFor: 'public interface' stamp: ' 4/5/09 22:18'!
actOn: aPresentation 
	 
	^self action 
		glamourValueWithArgs: 
			(Array 
				with: aPresentation 
				withAll: aPresentation entity asGlamorousArray)! !

!GLMAction methodsFor: 'public interface' stamp: 'jre 7/31/2009 15:42'!
actOn: aPresentation with: aMenuMorph
	 
	^self action 
		glamourValueWithArgs: 
			(Array 
				with: aPresentation 
				with: aMenuMorph
				)! !

!GLMAction methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
action 
	"The code that should be executed when this action is triggered." 
	 
	^action! !

!GLMAction methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
action: aBlock 
	"The code that should be executed when this action is triggered. 
 
	The block can take optional arguments, the first will always be the 
	presentation on which this action was triggered." 
	 
	action := aBlock! !

!GLMAction methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
category 
	"The name of the category that should be used when this action is displayed in a context menu." 
	 
	^category! !

!GLMAction methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
category: aString 
	"The name of the category that should be used when this action is displayed in a context menu." 
	 
	category := aString! !

!GLMAction methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
hasShortcut 
	 
	^self shortcut notNil! !

!GLMAction methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
hasTitle 
	 
	^self title notNil! !

!GLMAction methodsFor: 'testing' stamp: 'tg 9/17/2009 15:02'!
isCategorized
	 
	^self category notNil! !

!GLMAction methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
position 
	"The relative position within a context menu." 
	 
	^position! !

!GLMAction methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
position: anInteger 
	"The relative position within a context menu." 
	 
	position := anInteger! !

!GLMAction methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
shortcut 
	"Shortcut character that this action should be triggered with when the focus rests on the corresponding presentation. 
	Modifiers are platform specific an can not be defined." 
	 
	^shortcut! !

!GLMAction methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
shortcut: aCharacter 
	"Shortcut character that this action should be triggered with when the focus rests on the corresponding presentation. 
	Modifiers are platform specific an can not be defined." 
	 
	shortcut := aCharacter! !

!GLMAction methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
title 
	"Title that this action should use in a context menu." 
	 
	^title! !

!GLMAction methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
title: anObject 
	"Title that this action should use in a context menu." 
	 
	title := anObject! !

Object subclass: #GLMBundleOrigin
	instanceVariableNames: 'port active'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMBundleOrigin commentStamp: '<historical>' prior: 0!
Used by BundleTransmission to annotate its originating ports whether they are active or passive.

When a BundleTransmission consideres a port as active, the browser will trigger it when the corresponding port changes.!

!GLMBundleOrigin methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
beActive 
	 
	active := true! !

!GLMBundleOrigin methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
bePassive 
	 
	active := false! !

!GLMBundleOrigin methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
isActive 
	 
	^active ifNil: [active := true]! !

!GLMBundleOrigin methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
isPassive 
	 
	^self isActive not! !

!GLMBundleOrigin methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
port 
	 
	^port! !

!GLMBundleOrigin methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
port: aPort 
	 
	port := aPort! !

!GLMBundleOrigin methodsFor: 'accessing-convenience' stamp: ' 4/5/09 22:18'!
value 
	 
	^self port value! !

Object subclass: #GLMNoBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

GLMNoBrowser class
	instanceVariableNames: 'uniqueInstance'!

GLMNoBrowser class
	instanceVariableNames: 'uniqueInstance'!

!GLMNoBrowser classSide methodsFor: 'as yet unclassified' stamp: 'jorge.ressia 6/3/2009 08:30'!
initialize

	self initializeUniqueInstance! !

!GLMNoBrowser classSide methodsFor: 'as yet unclassified' stamp: 'jorge.ressia 6/3/2009 08:30'!
initializeUniqueInstance

	uniqueInstance := self basicNew! !

!GLMNoBrowser classSide methodsFor: 'as yet unclassified' stamp: 'jorge.ressia 6/3/2009 08:29'!
new

	^self uniqueInstance! !

!GLMNoBrowser classSide methodsFor: 'as yet unclassified' stamp: 'jorge.ressia 6/3/2009 08:30'!
uniqueInstance

	^uniqueInstance! !

!GLMNoBrowser methodsFor: 'accessing' stamp: 'jorge.ressia 6/2/2009 23:08'!
innerPortEvent: aPortEvent 
! !

Object subclass: #GLMPort
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

GLMPort subclass: #GLMBoundPort
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMBoundPort methodsFor: 'comparing' stamp: ' 4/5/09 22:18'!
= anObject 
	"Compare this port with another for equality. 
 
	This is used to compare ParentPorts with PanePorts where the earlier is a proxy for the latter." 
	 
	^((anObject isKindOf: GLMBoundPort) and: [self pane = anObject pane]) 
		and: [self name = anObject name]! !

!GLMBoundPort methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
hasPane 
	 
	^self pane notNil! !

!GLMBoundPort methodsFor: 'comparing' stamp: ' 4/5/09 22:18'!
hash 
	"Ports which are equal should return hash. 
 
	Since equality is used only for matching port proxies (ParentPort) with 
	their actual port, the hash function is overridden only in ParentPort." 
	 
	^super hash! !

!GLMBoundPort methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
pane 
	 
	self subclassResponsibility! !

GLMBoundPort subclass: #GLMPanePort
	instanceVariableNames: 'pane value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMPanePort commentStamp: '<historical>' prior: 0!
A port that belongs to a pane.

Bound ports have a few special characteristics in comparison to their superclass. For one, they don't just assign a value to themselves using #value: but rather generate a transmission that set the value so that the pane can handle the transmission and forward it to other ports if necessary, depending on the policy of the containing browser.!

!GLMPanePort methodsFor: 'accessing' stamp: 'jorge.ressia 5/30/2009 14:05'!
basicValue: anObject
	value := anObject. 
	! !

!GLMPanePort methodsFor: 'accessing' stamp: 'jorge.ressia 5/30/2009 13:05'!
changeValueTo: anObject in: aTransmissionContext
		| oldValue | 
	oldValue := self value. 
	self pane 
		notingPresentationChangeDo: 
			[value := anObject. 
			self pane 
				portEvent: 
					(GLMPortEvent 
						on: self
						previouslyValued: oldValue
						in: aTransmissionContext) ]! !

!GLMPanePort methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
pane 
	 
	^pane! !

!GLMPanePort methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
pane: aPane 
	 
	pane := aPane! !

!GLMPanePort methodsFor: 'accessing' stamp: 'jre 9/19/2009 08:16'!
printOn: aStream 
	 
	aStream 
		nextPutAll: 'Port (pane='; 
		nextPutAll: self pane name printString; 
		nextPutAll: ' name='; 
		nextPutAll: self name printString; 
		nextPutAll: ' value='; 
		nextPutAll: self value printString; 
		nextPut: $)! !

!GLMPanePort methodsFor: 'accessing' stamp: 'jre 9/18/2009 19:12'!
receive: aTransmission 
	 
	self value: aTransmission value in: aTransmission context! !

!GLMPanePort methodsFor: 'accessing' stamp: 'jre 9/18/2009 20:50'!
receive: aTransmission in: aContext
	 
	self value: aTransmission value in: aContext! !

!GLMPanePort methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
value 
	 
	^value! !

!GLMPanePort methodsFor: 'accessing' stamp: 'jre 9/19/2009 08:50'!
value: anObject  
	
	self changeValueTo: anObject in: OrderedCollection new.! !

!GLMPanePort methodsFor: 'accessing' stamp: 'jre 9/19/2009 10:54'!
value: anObject in: aContext
	aContext add: self.
	self changeValueTo: anObject in: aContext.! !

GLMBoundPort subclass: #GLMParentPort
	instanceVariableNames: 'presentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMParentPort methodsFor: 'comparing' stamp: ' 4/5/09 22:18'!
hash 
	 
	^self port hash! !

!GLMParentPort methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
pane 
	 
	^self presentation pane! !

!GLMParentPort methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
port 
	 
	^self pane port: self name! !

!GLMParentPort methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
presentation 
	 
	^presentation! !

!GLMParentPort methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
presentation: aPresentation 
	 
	presentation := aPresentation! !

!GLMParentPort methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
receive: aTransmission 
	 
	self port receive: aTransmission! !

!GLMParentPort methodsFor: 'accessing' stamp: 'jre 9/18/2009 20:55'!
receive: aTransmission in: aContext
	 
	self port receive: aTransmission in: aContext
	
! !

!GLMParentPort methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
value 
	 
	^self port value! !

!GLMParentPort methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
value: anObject 
	 
	self port value: anObject! !

!GLMPort methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
hasPane 
	 
	^false! !

!GLMPort methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
name 
	 
	^name! !

!GLMPort methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
name: aSymbol 
	 
	name := aSymbol! !

!GLMPort methodsFor: 'printing' stamp: ' 4/5/09 22:18'!
printOn: aStream 
	 
	aStream 
		nextPutAll: 'Port (name='; 
		nextPutAll: self name printString; 
		nextPutAll: ' value='; 
		nextPutAll: self value printString; 
		nextPut: $)! !

!GLMPort methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
receive: aTransmission 
	 
	self subclassResponsibility! !

!GLMPort methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
value 
	 
	self subclassResponsibility! !

!GLMPort methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
value: anObject 
	 
	self subclassResponsibility! !

GLMPort subclass: #GLMSimplePort
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMSimplePort methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
receive: aTransmission 
	 
	self value: aTransmission value! !

!GLMSimplePort methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
value 
	 
	^value! !

!GLMSimplePort methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
value: anObject 
	 
	value := anObject! !

Object subclass: #GLMPortEvent
	instanceVariableNames: 'port transmission oldValue transmissionContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMPortEvent classSide methodsFor: 'as yet unclassified' stamp: 'jorge.ressia 5/30/2009 11:47'!
on: aPort previouslyValued: anObject 
	^ self new 
		initializeOn: aPort
		previouslyValued: anObject! !

!GLMPortEvent classSide methodsFor: 'as yet unclassified' stamp: 'jorge.ressia 5/30/2009 12:55'!
on: aPort previouslyValued: anObject in: aTransmissionContext 
	^self new initializeOn: aPort previouslyValued: anObject in: aTransmissionContext ! !

!GLMPortEvent methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
hasChanged 
	"Answer whether the port value changed due to the event." 
	 
	^self value ~= self oldValue! !

!GLMPortEvent methodsFor: 'as yet unclassified' stamp: 'jorge.ressia 5/30/2009 13:01'!
initializeOn: aPort previouslyValued: anObject 
	self initializeOn: aPort previouslyValued: anObject in: OrderedCollection new! !

!GLMPortEvent methodsFor: 'as yet unclassified' stamp: 'jorge.ressia 5/30/2009 12:58'!
initializeOn: aPort previouslyValued: anObject in: aTransmissionContext 
	port := aPort.
	oldValue := anObject.
	transmissionContext := aTransmissionContext! !

!GLMPortEvent methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
oldValue 
	 
	^oldValue! !

!GLMPortEvent methodsFor: 'accessing-convenience' stamp: ' 4/5/09 22:18'!
pane 
	 
	^self port pane! !

!GLMPortEvent methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
port 
	 
	^port! !

!GLMPortEvent methodsFor: 'accessing-convenience' stamp: ' 4/5/09 22:18'!
portName 
	 
	^self port name! !

!GLMPortEvent methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
transmission 
	 
	^transmission! !

!GLMPortEvent methodsFor: 'as yet unclassified' stamp: 'jre 9/19/2009 11:34'!
transmissionContext
	^OrderedCollection withAll: transmissionContext! !

!GLMPortEvent methodsFor: 'accessing-convenience' stamp: ' 4/5/09 22:18'!
value 
	 
	^self port value! !

Object subclass: #GLMRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMRenderer methodsFor: 'rendering' stamp: ' 4/5/09 22:18'!
doOpen: aUI 
	 
	^self subclassResponsibility! !

!GLMRenderer methodsFor: 'rendering' stamp: ' 4/5/09 22:18'!
open: aRenderable 
	 
	^self doOpen: (self render: aRenderable)! !

!GLMRenderer methodsFor: 'rendering' stamp: ' 4/5/09 22:18'!
render: aRenderable 
	 
	^aRenderable renderGlamorouslyOn: self! !

!GLMRenderer methodsFor: 'rendering' stamp: ' 4/5/09 22:18'!
renderPane: aPane 
	 
	^nil! !

!GLMRenderer methodsFor: 'rendering' stamp: 'tg 5/24/2009 19:30'!
renderPresentation: aPresentation 

	^ nil! !

Object subclass: #GLMTransmission
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

GLMTransmission subclass: #GLMBundleTransmission
	instanceVariableNames: 'presentations destination origins'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMBundleTransmission commentStamp: '<historical>' prior: 0!
The main transmission kind.

Instance Variables:
	destination	<BoundPort>	description of destination
	origins	<OrderedCollection>	description of origins
	presentations	<OrderedCollection>	description of presentations

!

!GLMBundleTransmission methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
activeOrigins 
	 
	^(self bundleOrigins select: [:each | each isActive]) 
		collect: [:each | each port]! !

!GLMBundleTransmission methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
addActiveOrigin: aPort 
	 
	self bundleOrigins 
		add: 
			((GLMBundleOrigin new) 
				port: aPort; 
				beActive; 
				yourself)! !

!GLMBundleTransmission methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
addPassiveOrigin: aPort 
	 
	self bundleOrigins 
		add: 
			((GLMBundleOrigin new) 
				port: aPort; 
				bePassive; 
				yourself)! !

!GLMBundleTransmission methodsFor: 'accessing-convenience' stamp: ' 4/5/09 22:18'!
addPresentation: aPresentation 
	 
	self presentations addLast: aPresentation! !

!GLMBundleTransmission methodsFor: 'accessing-convenience' stamp: ' 4/5/09 22:18'!
addPresentations: aCollection 
	 
	aCollection do: [:each | self addPresentation: each]! !

!GLMBundleTransmission methodsFor: 'private accessing' stamp: ' 4/5/09 22:18'!
bundleOrigins 
	 
	^origins ifNil: [origins := OrderedCollection new]! !

!GLMBundleTransmission methodsFor: 'private' stamp: ' 4/5/09 22:18'!
clearOrigins 
	 
	origins := nil! !

!GLMBundleTransmission methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
destination 
	 
	^destination! !

!GLMBundleTransmission methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
destination: aPort 
	 
	destination := aPort! !

!GLMBundleTransmission methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
originatesAt: aPort 
	 
	^self activeOrigins includes: aPort! !

!GLMBundleTransmission methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
origins 
	 
	^self bundleOrigins collect: [:each | each port]! !

!GLMBundleTransmission methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
passiveOrigins 
	 
	^(self bundleOrigins select: [:each | each isPassive]) 
		collect: [:each | each port]! !

!GLMBundleTransmission methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
presentations 
	 
	^presentations ifNil: [presentations := OrderedCollection new]! !

!GLMBundleTransmission methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
presentations: aCollection 
	 
	presentations := aCollection! !

!GLMBundleTransmission methodsFor: 'transmitting' stamp: 'jorge.ressia 5/30/2009 13:47'!
printOn: aStream 
	 
	aStream 
		nextPutAll: 'BundleTransmission (origin='; 
		nextPutAll: self origins first printString; 
		nextPutAll: ' destination='; 
		nextPutAll: self destination printString; 
		nextPut: $)
	 
	! !

!GLMBundleTransmission methodsFor: 'transmitting' stamp: 'jorge.ressia 6/2/2009 17:03'!
transmit 
	self destination hasPane 
		ifTrue: 
			[self destination pane clear.
			self destination pane addPresentations: self presentations]. 
	self destination receive: self! !

!GLMBundleTransmission methodsFor: 'transmitting' stamp: 'jre 9/19/2009 08:24'!
transmitIn: aContext
	self destination hasPane 
		ifTrue: 
			[self destination pane clearIn: aContext.
			self destination pane addPresentations: self presentations]. 
	self destination receive: self in: aContext! !

!GLMBundleTransmission methodsFor: 'transmitting' stamp: ' 4/5/09 22:18'!
value 
	 
	^self origins size = 1 
		ifTrue: [self origins first value] 
		ifFalse: 
			[GLMMultiValue withAll: (self origins collect: [:each | each value])]! !

GLMTransmission subclass: #GLMSimpleTransmission
	instanceVariableNames: 'origin destination'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

GLMSimpleTransmission subclass: #GLMSimpleTransformingTransmission
	instanceVariableNames: 'transformation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Core'!

!GLMSimpleTransformingTransmission methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
transformation 
	 
	^transformation ifNil: [#yourself]! !

!GLMSimpleTransformingTransmission methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
transformation: anObject 
	 
	transformation := anObject! !

!GLMSimpleTransformingTransmission methodsFor: 'transmitting' stamp: ' 4/5/09 22:18'!
value 
	 
	^self transformation glamourValue: self origin value! !

!GLMSimpleTransmission methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
destination 
	 
	^destination! !

!GLMSimpleTransmission methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
destination: aPort 
	 
	destination := aPort! !

!GLMSimpleTransmission methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
origin 
	 
	^origin! !

!GLMSimpleTransmission methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
origin: aPort 
	 
	origin := aPort! !

!GLMSimpleTransmission methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
originatesAt: aPort 
	 
	^self origin = aPort! !

!GLMSimpleTransmission methodsFor: 'transmitting' stamp: ' 4/5/09 22:18'!
transmit 
	 
	self destination receive: self! !

!GLMSimpleTransmission methodsFor: 'transmitting' stamp: 'jre 9/18/2009 20:53'!
transmitIn: aContext
	 
	self destination receive: self in: aContext! !

!GLMSimpleTransmission methodsFor: 'transmitting' stamp: ' 4/5/09 22:18'!
value 
	 
	^self origin value! !

!GLMTransmission methodsFor: 'transmitting' stamp: 'jre 9/18/2009 19:17'!
context
	 context ifNil: [context := OrderedCollection new].
	^context! !

!GLMTransmission methodsFor: 'transmitting' stamp: 'jre 9/18/2009 19:46'!
context: aContext
	 context := aContext! !

!GLMTransmission methodsFor: 'testing' stamp: ' 4/5/09 22:18'!
originatesAt: aPort 
	 
	^false! !

!GLMTransmission methodsFor: 'transmitting' stamp: ' 4/5/09 22:18'!
transmit 
	 
	self subclassResponsibility! !

!GLMTransmission methodsFor: 'transmitting' stamp: ' 4/5/09 22:18'!
value 
	 
	self subclassResponsibility! !
GLMNoBrowser initialize!
